package quiz;

public class GMap {
	private int row;

	private int column;

	private char[][] board;

	private char[][] answerBoard;

	public GMap(int row, int column) {
		this.row = row;
		this.column = column;
		board = new char[row][column];
		answerBoard = new char[row][column];
	}

	public char[][] getBoard() {
		return board;
	}

	public void setBoard(char[][] board) {
		this.board = board;
	}

	public int getColumn() {
		return column;
	}

	public void setColumn(int column) {
		this.column = column;
	}

	public int getRow() {
		return row;
	}

	public void setRow(int row) {
		this.row = row;
	}

	public void convertToAnswerMap() {
		int numberOfMines = 0;
		char valueOfSpot = '*';
		for (int i = 0; i < row; i++) {
			for (int j = 0; j < column; j++) {
				if (board[i][j] != '*') {
					numberOfMines = countMines(i, j);
					valueOfSpot = (char) (numberOfMines + 48);
				}
				answerBoard[i][j] = valueOfSpot;
				valueOfSpot = '*';
			}
		}
	}

	private int countMines(int row, int column) {
		int count = 0;
		// ٷ 
		if (row != 0) {
			if (board[row - 1][column] == '*')
				count++;
		}
		//  
		if (row != 0 && column != 0) {
			if (board[row - 1][column - 1] == '*')
				count++;
		}
		//  
		if (row != 0 && ((column + 1) != this.column)) {
			if (board[row - 1][column + 1] == '*')
				count++;
		}
		// 
		if (column != 0) {
			if (board[row][column - 1] == '*')
				count++;
		}
		// 
		if ((column + 1) != this.column) {
			if (board[row][column + 1] == '*')
				count++;
		}
		// Ʒ
		if ((row + 1) != this.row) {
			if (board[row + 1][column] == '*')
				count++;
		}
		//  Ʒ
		if (((row + 1) != this.row) && column != 0) {
			if (board[row + 1][column - 1] == '*')
				count++;
		}
		//  Ʒ
		if (((row + 1) != this.row) && ((column + 1) != this.column)) {
			if (board[row + 1][column + 1] == '*')
				count++;
		}
		return count;
	}

	public String toString() {
		String result = "";
		for (int i = 0; i < row; i++) {
			for (int j = 0; j < column; j++) {
				result += board[i][j];
			}
			result += "\n";
		}
		return result;
	}

	public String answerToString() {
		String result = "";
		for (int i = 0; i < row; i++) {
			for (int j = 0; j < column; j++) {
				result += answerBoard[i][j] + " ";
			}
			result += "\n";
		}
		return result;
	}

	public char[][] getAnswerBoard() {
		return answerBoard;
	}
}
